from numba import d
from numba.decorators import jit
import time
import numpy as np
import numexpr as ne

N = 10*1000*1000

def poly(x, y):
    for i in range(N):
        # y[i] = 0.25*x[i]**3 + 0.75*x[i]**2 + 1.5*x[i] - 2
        y[i] = ((0.25*x[i] + 0.75)*x[i] + 1.5)*x[i] - 2

t = time.time()
cpoly = jit(arg_types=[d[:], d[:]])(poly)
print "Compilation time:", round(time.time()-t, 3)

x = np.linspace(-1, 1, N)
y = np.empty(N, dtype=np.float64)

import time
start = time.time()
#y = 0.25*x**3 + 0.75*x**2 + 1.5*x - 2
y = ((0.25*x + 0.75)*x + 1.5)*x - 2
duration = time.time() - start
print "Result from numpy is %s in %s (msec)" % (y, round(duration,3))

import time
start = time.time()
#y = ne.evaluate("0.25*x**3 + 0.75*x**2 + 1.5*x - 2")
y = ne.evaluate("((0.25*x + 0.75)*x + 1.5)*x - 2")
duration2 = time.time() - start
print "Result from numexpr is %s in %s sec" % (y, round(duration2,3))

start = time.time()
cpoly(x, y)
duration3 = time.time() - start
print "Result from compiled is %s in %s sec" % (y, round(duration3,3))

print "numexpr speed up is %s" % (duration / duration2)
print "Numba speed up is %s" % (duration / duration3)
